unit XYZCli;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, StdCtrls,
  ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    IdTCPClient1: TIdTCPClient;
    Memo1: TMemo;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    procedure Panel1Click(Sender: TObject);
    procedure IdTCPClient1Status(axSender: TObject;
      const axStatus: TIdStatus; const asStatusText: String);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    OldApplIdleEvent: TIdleEvent;
    procedure ApplIdleEvent(Sender: TObject; var Done: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  OldApplIdleEvent:= Forms.Application.OnIdle;
  Forms.Application.OnIdle:= ApplIdleEvent;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  If IdTCPClient1.Connected Then
    IdTCPClient1.DisConnect;
  Forms.Application.OnIdle:= OldApplIdleEvent;
end;
//
// Try to catch the IdTCPServer.Disconnect. This is a IdTCPClient bug.
//
procedure TForm1.ApplIdleEvent(Sender: TObject; var Done: Boolean);
var
  c : char;
begin
  If IdTCPClient1.Connected Then Begin
    If IdTCPClient1.Binding.Readable( 100 ) Then Begin
      If IdTCPClient1.Binding.Recv( c, 1, 2{MSG_PEEK} ) = 0 Then
        IdTCPClient1.DisConnect;
    End;
  End;

  If Assigned(OldApplIdleEvent) Then
    OldApplIdleEvent( Sender, Done );
end;

procedure TForm1.Panel1Click(Sender: TObject);
begin
  If NOT IdTCPClient1.Connected Then
   IdTCPClient1.Connect;
  IdTCPClient1.WriteLn('XXXXX');
  Memo1.Lines.Add(IdTCPClient1.ReadLn);
  IdTCPClient1.WriteLn('QUIT');
  Memo1.Lines.Add(IdTCPClient1.ReadLn);
  Memo1.Lines.Add( intToStr(IdTCPClient1.ResultNo) );
end;


procedure TForm1.IdTCPClient1Status(axSender: TObject;
  const axStatus: TIdStatus; const asStatusText: String);
begin
  StatusBar1.SimpleText:= asStatusText;
end;


end.
